diff --git a/CHANGELOG b/CHANGELOG
index 605d407ac4c..824858c41fc 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -1,4 +1,6 @@
 0.83.1
+  - dosbox-x.conf is now recognized as the default config
+    file name in addition to dosbox.conf (Wengier)
   - Tandy DAC output fixed to slowly ramp last sample to
     zero DC sample (128) when switched off. This fixes
     loud popping (DC offset) problems with Tandy DAC
@@ -20,10 +22,14 @@
   - Support for pipes (|), e.g. "DIR | MORE" should now
     work as expected; it is recommended to set the %TEMP%
     environment variable before using pipes (Wengier)
+  - Improved redirections using "<" or ">" (Wengier)
+  - Improved Ctrl+C handling in some commands (Wengier)
   - Improved -get & -set options for the CONFIG command,
     e.g. support for config options with spaces (Wengier)
   - Improved REN (or RENAME) command to support wildcards
     (* and ?) in the source and/or target files (Wengier) 
+  - Added BREAK, VERIFY and TRUENAME commands as in a real
+    DOS system. Type "[command] /?" for help info (Wengier)
   - Implemented FOR command to run a specified command for
     each file in a set of files. Also added LFNFOR command
     to control whether to use long filenames in the FOR
@@ -79,8 +85,19 @@
     The DOS device name can also be changed with
     the "dos clipboard device name" setting in
     dosbox.conf. (Wengier)
-  - Updated the PasteClipboard feature to support
-    Unicode text translations. (Wengier)
+  - Added support for using the right mouse button
+    to copy and paste from the Windows clipboard; the
+    config option "clip_key_modifier" can be used to
+    Change the keyboard modifier such as none, alt, ctrl,
+    shift, or disable this feature (default). (Wengier)
+  - Updated the PasteClipboard feature in SDL1 build
+    to support Unicode text translations. (Wengier)
+  - Fixed the PasteClipboard feature in SDL2 build;
+    a keyboard buffer expansion program like keybuf.com
+    is recommended to paste long contents from the
+    Windows clipboard in SDL2 build. (Wengier)
+  - Support for DOSLIB2's w95sysrg/w95sysrs utils to
+    get/set system registry location in DOS 7+. (Wengier)
   - Long filename support added, adapted from
     the vDosPlus project. It will be enabled with
     an initial DOS version of 7.0 or higher. (Wengier)
diff --git a/dosbox.reference.conf b/dosbox.reference.conf
index 0049476f198..3cfa098bffa 100644
--- a/dosbox.reference.conf
+++ b/dosbox.reference.conf
@@ -1,5 +1,5 @@
-# This is the configuration file for DOSBox 0.83.1. (Please use the latest version of DOSBox)
-# Lines starting with a # are comment lines and are ignored by DOSBox.
+# This is the configuration file for DOSBox-X 0.83.1. (Please use the latest version of DOSBox-X)
+# Lines starting with a # are comment lines and are ignored by DOSBox-X.
 # They are used to (briefly) document the effect of each option.
 # To write out ALL options, use command 'config -all' with -wc or -writeconf options.
 
@@ -96,6 +96,12 @@ fileio      = false
 #          autolock: Mouse will automatically lock, if you click on the screen. (Press CTRL-F10 to unlock)
 # autolock_feedback: Autolock status feedback type, i.e. visual, auditive, none.
 #                      Possible values: none, beep, flash.
+# clip_key_modifier: Change the keyboard modifier for the Windows clipboard copy/paste function using the right mouse button.
+#                      Set to "none" if no modifier is desired. Set to "disabled" will disable this feature (default).
+#                      Possible values: none, alt, lalt, ralt, ctrl, lctrl, rctrl, shift, lshift, rshift, disabled.
+#  clip_paste_speed: Set keyboard speed for pasting from the Windows clipboard.
+#                      If the default setting of 20 causes lost keystrokes, increase the number.
+#                      Or experiment with decreasing the number for applications that accept keystrokes quickly.
 #       sensitivity: Mouse sensitivity. The optional second parameter specifies vertical sensitivity (e.g. 100,-50).
 #   mouse_emulation: When is mouse emulated ?
 #                      integration: when not locked
@@ -122,6 +128,8 @@ windowresolution  = original
 output            = surface
 autolock          = false
 autolock_feedback = beep
+clip_key_modifier = disabled
+clip_paste_speed  = 20
 sensitivity       = 100
 mouse_emulation   = locked
 waitonerror       = true
@@ -1511,9 +1519,6 @@ dongle    = false
 #                        dos clipboard device name: Set DOS device name (up to 8 characters) for bidirectional communications with the Windows clipboard.
 #                                                     If unset or invalid, the default name CLIP$ will be used (e.g. "TYPE CLIP$" shows the clipboard contents).
 #                                                     It has no effect if "dos clipboard device enable" is false, and it is deactivated if the secure mode is enabled.
-#                        dos clipboard paste speed: Set keyboard speed for pasting from the Windows clipboard.
-#                                                     If the default setting of 20 causes lost keystrokes, increase the number.
-#                                                     Or experiment with decreasing the number for applications that accept keystrokes quickly.
 xms                                              = true
 xms handles                                      = 0
 shell configuration as commands                  = false
@@ -1573,7 +1578,6 @@ con device use int 16h to detect keyboard input  = true
 zero memory on int 21h memory allocation         = false
 dos clipboard device enable                      = false
 dos clipboard device name                        = CLIP$
-dos clipboard paste speed                        = 20
 
 [ipx]
 # ipx: Enable ipx over UDP/IP emulation.
diff --git a/include/mouse.h b/include/mouse.h
index 22759ef2d0a..88e05aca590 100644
--- a/include/mouse.h
+++ b/include/mouse.h
@@ -35,6 +35,11 @@ void Mouse_ChangePS2Callback(Bit16u pseg, Bit16u pofs);
 
 
 void Mouse_CursorMoved(float xrel,float yrel,float x,float y,bool emulate);
+#if defined(WIN32)
+const char* Mouse_GetSelected(int x1, int y1, int x2, int y2, int w, int h);
+void Mouse_Select(int x1, int y1, int x2, int y2, int w, int h);
+void Restore_Text(int x1, int y1, int x2, int y2, int w, int h);
+#endif
 void Mouse_ButtonPressed(Bit8u button);
 void Mouse_ButtonReleased(Bit8u button);
 
diff --git a/include/sdlmain.h b/include/sdlmain.h
index 9d64eb4d8c0..cc3f4a2b3be 100644
--- a/include/sdlmain.h
+++ b/include/sdlmain.h
@@ -169,8 +169,9 @@ struct SDL_Block {
     Bit32u focus_ticks = 0;
 #endif
     // state of alt-keys for certain special handlings
-    Bit16u laltstate = 0;
-    Bit16u raltstate = 0;
+    Bit16u laltstate = 0, raltstate = 0;
+    Bit16u lctrlstate = 0, rctrlstate = 0;
+    Bit16u lshiftstate = 0, rshiftstate = 0;
     bool must_redraw_all = false;
     bool deferred_resize = false;
     bool init_ignore = false;
diff --git a/include/shell.h b/include/shell.h
index 552dbee1010..7bb71f5219c 100644
--- a/include/shell.h
+++ b/include/shell.h
@@ -270,6 +270,7 @@ class DOS_Shell : public Program {
     /*! \brief      Change TTY (console) device (CTTY)
      */
 	void CMD_CTTY(char * args);
+    void CMD_TRUENAME(char * args);
     void CMD_DXCAPTURE(char * args);
 
     /*! \brief      Looping execution (FOR)
diff --git a/src/debug/debug_win32.cpp b/src/debug/debug_win32.cpp
index faca1715233..af40ee78a69 100644
--- a/src/debug/debug_win32.cpp
+++ b/src/debug/debug_win32.cpp
@@ -72,7 +72,7 @@ static void ResizeConsole( HANDLE hConsole, SHORT xSize, SHORT ySize ) {
 
 void WIN32_Console() {
 	AllocConsole();
-	SetConsoleTitle("DOSBox Debugger");
+	SetConsoleTitle("DOSBox-X Debugger");
 	ResizeConsole(GetStdHandle(STD_OUTPUT_HANDLE),80,50);
 }
 #endif
diff --git a/src/dos/dos_misc.cpp b/src/dos/dos_misc.cpp
index 90cc5d80975..2aea107d474 100644
--- a/src/dos/dos_misc.cpp
+++ b/src/dos/dos_misc.cpp
@@ -93,6 +93,7 @@ static Bitu INT2A_Handler(void) {
 extern RealPt DOS_DriveDataListHead;       // INT 2Fh AX=0803h DRIVER.SYS drive data table list
 
 // INT 2F
+char regpath[CROSS_LEN+1]="C:\\WINDOWS\\SYSTEM.DAT";
 static bool DOS_MultiplexFunctions(void) {
     char name[256];
 	switch (reg_ax) {
@@ -230,11 +231,16 @@ static bool DOS_MultiplexFunctions(void) {
         return true;
     case 0x1613:    /* Get SYSTEM.DAT path */
 		if (dos.version.major < 7) return false;
-        strcpy(name,"C:\\WINDOWS\\SYSTEM.DAT");
+        strcpy(name,regpath);
         MEM_BlockWrite(SegPhys(es)+reg_di,name,(Bitu)(strlen(name)+1));
         reg_ax=0;
         reg_cx=(Bit16u)strlen(name);
         return true;
+    case 0x1614:    /* Set SYSTEM.DAT path */
+		if (dos.version.major < 7) return false;
+        MEM_StrCopy(SegPhys(es)+reg_di,regpath,CROSS_LEN+1);
+        reg_ax=0;
+        return true;
     case 0x1600:    /* Windows enhanced mode installation check */
         // Leave AX as 0x1600, indicating that neither Windows 3.x enhanced mode, Windows/386 2.x
         // nor Windows 95 are running, nor is XMS version 1 driver installed
@@ -502,7 +508,7 @@ static bool DOS_MultiplexFunctions(void) {
         return true;
     case 0x4a17:    /* Write bootlog */
         MEM_StrCopy(SegPhys(ds)+reg_dx,name,255);
-        LOG(LOG_DOSMISC,LOG_NORMAL)("BOOTLOG: %s\n",name);
+        LOG_MSG("BOOTLOG: %s\n",name);
         return true;
     case 0x4a18:    /* Close bootlog */
         return true;
diff --git a/src/dos/dos_programs.cpp b/src/dos/dos_programs.cpp
index 772bf308c30..c62475ee36a 100644
--- a/src/dos/dos_programs.cpp
+++ b/src/dos/dos_programs.cpp
@@ -1675,6 +1675,11 @@ static void BOOT_ProgramStart(Program * * make) {
 class LOADROM : public Program {
 public:
     void Run(void) {
+		if (cmd->FindExist("-?", false) || cmd->FindExist("/?", false)) {
+			WriteOut(MSG_Get("PROGRAM_LOADROM_HELP"));
+			return;
+		}
+
         if (!(cmd->FindCommand(1, temp_line))) {
             WriteOut(MSG_Get("PROGRAM_LOADROM_SPECIFY_FILE"));
             return;
@@ -2383,7 +2388,7 @@ void LOADFIX::Run(void)
         kb = 1024;
     }
 
-    if (cmd->FindExist("-?", false)) {
+    if (cmd->FindExist("-?", false) || cmd->FindExist("/?", false)) {
         WriteOut(MSG_Get("PROGRAM_LOADFIX_HELP"));
         return;
     }
@@ -4539,7 +4544,7 @@ void DOS_SetupPrograms(void) {
     MSG_Add("PROGRAM_LOADFIX_DEALLOCALL","Used memory freed.\n");
     MSG_Add("PROGRAM_LOADFIX_ERROR","Memory allocation error.\n");
     MSG_Add("PROGRAM_LOADFIX_HELP",
-        "Reduces the amount of available conventional or XMS memory\n\n"
+        "Reduces the amount of available conventional or XMS memory.\n\n"
         "LOADFIX [-xms] [-{ram}] [{program}]\n"
         "LOADFIX -f [-xms]\n\n"
         "  -xms        Allocates memory from XMS rather than conventional memory\n"
@@ -4566,23 +4571,23 @@ void DOS_SetupPrograms(void) {
     MSG_Add("PROGRAM_RESCAN_SUCCESS","Drive cache cleared.\n");
 
     MSG_Add("PROGRAM_INTRO",
-        "\033[2J\033[32;1mWelcome to DOSBox\033[0m, an x86 emulator with sound and graphics.\n"
-        "DOSBox creates a shell for you which looks like old plain DOS.\n"
+        "\033[2J\033[32;1mWelcome to DOSBox-X\033[0m, an x86 emulator with sound and graphics.\n"
+        "DOSBox-X creates a shell for you which looks like old plain DOS.\n"
         "\n"
-        "\033[31;1mDOSBox will stop/exit without a warning if an error occurred!\033[0m\n"
+        "\033[31;1mDOSBox-X will stop/exit without a warning if an error occurred!\033[0m\n"
         "\n"
         "\n" );
     if (machine == MCH_PC98) {
         MSG_Add("PROGRAM_INTRO_MENU_UP",
             "\033[44m\033[K\033[0m\n"
-            "\033[44m\033[K\033[1m\033[1m\t\t\t\t\t\t\t  DOSBox Introduction \033[0m\n"
+            "\033[44m\033[K\033[1m\033[1m\t\t\t\t\t\t\t  DOSBox-X Introduction \033[0m\n"
             "\033[44m\033[K\033[1m\033[1m \x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\x86\x43\033[0m\n"
             "\033[44m\033[K\033[0m\n"
             );
     } else {
         MSG_Add("PROGRAM_INTRO_MENU_UP",
             "\033[44m\033[K\033[0m\n"
-            "\033[44m\033[K\033[1m\033[1m\t\t\t\t\t\t\t  DOSBox Introduction \033[0m\n"
+            "\033[44m\033[K\033[1m\033[1m\t\t\t\t\t\t\t  DOSBox-X Introduction \033[0m\n"
             "\033[44m\033[K\033[1m\033[1m \xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\xC4\033[0m\n"
             "\033[44m\033[K\033[0m\n"
             );
@@ -4592,18 +4597,18 @@ void DOS_SetupPrograms(void) {
     MSG_Add("PROGRAM_INTRO_MENU_USAGE","Usage");
     MSG_Add("PROGRAM_INTRO_MENU_INFO","Information");
     MSG_Add("PROGRAM_INTRO_MENU_QUIT","Quit");
-    MSG_Add("PROGRAM_INTRO_MENU_BASIC_HELP","\n\033[1m   \033[1m\033[KMOUNT allows you to connect real hardware to DOSBox's emulated PC.\033[0m\n");
-    MSG_Add("PROGRAM_INTRO_MENU_CDROM_HELP","\n\033[1m   \033[1m\033[KTo mount your CD-ROM in DOSBox, you have to specify some additional options\n   when mounting the CD-ROM.\033[0m\n");
-    MSG_Add("PROGRAM_INTRO_MENU_USAGE_HELP","\n\033[1m   \033[1m\033[KAn overview of the command line options you can give to DOSBox.\033[0m\n");
-    MSG_Add("PROGRAM_INTRO_MENU_INFO_HELP","\n\033[1m   \033[1m\033[KHow to get more information about DOSBox.\033[0m\n");
+    MSG_Add("PROGRAM_INTRO_MENU_BASIC_HELP","\n\033[1m   \033[1m\033[KMOUNT allows you to connect real hardware to DOSBox-X's emulated PC.\033[0m\n");
+    MSG_Add("PROGRAM_INTRO_MENU_CDROM_HELP","\n\033[1m   \033[1m\033[KTo mount your CD-ROM in DOSBox-X, you have to specify some additional options\n   when mounting the CD-ROM.\033[0m\n");
+    MSG_Add("PROGRAM_INTRO_MENU_USAGE_HELP","\n\033[1m   \033[1m\033[KAn overview of the command line options you can give to DOSBox-X.\033[0m\n");
+    MSG_Add("PROGRAM_INTRO_MENU_INFO_HELP","\n\033[1m   \033[1m\033[KHow to get more information about DOSBox-X.\033[0m\n");
     MSG_Add("PROGRAM_INTRO_MENU_QUIT_HELP","\n\033[1m   \033[1m\033[KExit from Intro.\033[0m\n");
     MSG_Add("PROGRAM_INTRO_USAGE_TOP",
-        "\033[2J\033[32;1mAn overview of the command line options you can give to DOSBox.\033[0m\n"
+        "\033[2J\033[32;1mAn overview of the command line options you can give to DOSBox-X.\033[0m\n"
         "Windows Users must open cmd.exe or command.com or edit the shortcut to\n"
-        "DOSBox.exe for this.\n\n"
-        "dosbox [name] [-exit] [-c command] [-fullscreen] [-conf congfigfile]\n"
-        "       [-lang languagefile] [-machine machinetype] [-noconsole]\n"
-        "       [-startmapper] [-noautoexec] [-scaler scaler | -forcescaler scaler]\n       [-version]\n\n"
+        "DOSBox-X.exe for this.\n\n"
+        "dosbox-x [name] [-exit] [-c command] [-fullscreen] [-conf congfigfile]\n"
+        "         [-lang languagefile] [-machine machinetype] [-noconsole]\n"
+        "         [-startmapper] [-noautoexec] [-scaler scaler | -forcescaler scaler]\n       [-version]\n\n"
         );
     MSG_Add("PROGRAM_INTRO_USAGE_1",
         "\033[33;1m  name\033[0m\n"
@@ -4611,7 +4616,7 @@ void DOS_SetupPrograms(void) {
         "\tIf name is an executable it will mount the directory of name\n"
         "\tas the C: drive and execute name.\n\n"
         "\033[33;1m  -exit\033[0m\n"
-        "\tDOSBox will close itself when the DOS application name ends.\n\n"
+        "\tDOSBox-X will close itself when the DOS application name ends.\n\n"
         "\033[33;1m  -c\033[0m command\n"
         "\tRuns the specified command before running name. Multiple commands\n"
         "\tcan be specified. Each command should start with -c, though.\n"
@@ -4620,19 +4625,19 @@ void DOS_SetupPrograms(void) {
         );
     MSG_Add("PROGRAM_INTRO_USAGE_2",
         "\033[33;1m  -fullscreen\033[0m\n"
-        "\tStarts DOSBox in fullscreen mode.\n\n"
+        "\tStarts DOSBox-X in fullscreen mode.\n\n"
         "\033[33;1m  -conf\033[0m configfile\n"
-        "\tStart DOSBox with the options specified in configfile.\n"
+        "\tStart DOSBox-X with the options specified in configfile.\n"
         "\tSee README for more details.\n\n"
         "\033[33;1m  -lang\033[0m languagefile\n"
-        "\tStart DOSBox using the language specified in languagefile.\n\n"
+        "\tStart DOSBox-X using the language specified in languagefile.\n\n"
         "\033[33;1m  -noconsole\033[0m (Windows Only)\n"
-        "\tStart DOSBox without showing the console window. Output will\n"
+        "\tStart DOSBox-X without showing the console window. Output will\n"
         "\tbe redirected to stdout.txt and stderr.txt\n"
         );
     MSG_Add("PROGRAM_INTRO_USAGE_3",
         "\033[33;1m  -machine\033[0m machinetype\n"
-        "\tSetup DOSBox to emulate a specific type of machine. Valid choices are:\n"
+        "\tSetup DOSBox-X to emulate a specific type of machine. Valid choices are:\n"
         "\thercules, cga, pcjr, tandy, vga (default). The machinetype affects\n"
         "\tboth the videocard and the available soundcards.\n\n"
         "\033[33;1m  -startmapper\033[0m\n"
@@ -4649,11 +4654,11 @@ void DOS_SetupPrograms(void) {
         "For information about CD-ROM support, type \033[34;1mintro cdrom\033[0m\n"
         "For information about special keys, type \033[34;1mintro special\033[0m\n"
         "For information about usage, type \033[34;1mintro usage\033[0m\n\n"
-        "For the latest version of DOSBox, go to \033[34;1mhttp://www.dosbox.com\033[0m\n"
+        "For the latest version of DOSBox-X, go to \033[34;1mhttp://www.dosbox-x.com\033[0m\n"
         "\n"
-        "For more information about DOSBox, read README first!\n"
+        "For more information about DOSBox-X, read README first!\n"
         "\n"
-        "\033[34;1mhttp://www.dosbox.com/wiki\033[0m\n"
+        "\033[34;1mhttps://github.com/joncampbell123/dosbox-x/wiki\033[0m\n"
         "\033[34;1mhttp://vogons.zetafleet.com\033[0m\n"
         );
     MSG_Add("PROGRAM_INTRO_MOUNT_START",
@@ -4736,14 +4741,14 @@ void DOS_SetupPrograms(void) {
             );
     }
     MSG_Add("PROGRAM_INTRO_CDROM",
-        "\033[2J\033[32;1mHow to mount a Real/Virtual CD-ROM Drive in DOSBox:\033[0m\n"
-        "DOSBox provides CD-ROM emulation on several levels.\n"
+        "\033[2J\033[32;1mHow to mount a Real/Virtual CD-ROM Drive in DOSBox-X:\033[0m\n"
+        "DOSBox-X provides CD-ROM emulation on several levels.\n"
         "\n"
         "The \033[33mbasic\033[0m level works on all CD-ROM drives and normal directories.\n"
         "It installs MSCDEX and marks the files read-only.\n"
         "Usually this is enough for most games:\n"
         "\033[34;1mmount d \033[0;31mD:\\\033[34;1m -t cdrom\033[0m   or   \033[34;1mmount d C:\\example -t cdrom\033[0m\n"
-        "If it doesn't work you might have to tell DOSBox the label of the CD-ROM:\n"
+        "If it doesn't work you might have to tell DOSBox-X the label of the CD-ROM:\n"
         "\033[34;1mmount d C:\\example -t cdrom -label CDLABEL\033[0m\n"
         "\n"
         "The \033[33mnext\033[0m level adds some low-level support.\n"
@@ -4763,7 +4768,7 @@ void DOS_SetupPrograms(void) {
     MSG_Add("PROGRAM_BOOT_NOT_EXIST","Bootdisk file does not exist.  Failing.\n");
     MSG_Add("PROGRAM_BOOT_NOT_OPEN","Cannot open bootdisk file.  Failing.\n");
     MSG_Add("PROGRAM_BOOT_WRITE_PROTECTED","Image file is read-only! Boot in write-protected mode.\n");
-    MSG_Add("PROGRAM_BOOT_PRINT_ERROR","This command boots DOSBox from either a floppy or hard disk image.\n\n"
+    MSG_Add("PROGRAM_BOOT_PRINT_ERROR","This command boots DOSBox-X from either a floppy or hard disk image.\n\n"
         "For this command, one can specify a succession of floppy disks swappable\n"
         "by pressing Ctrl-F4, and -l specifies the mounted drive to boot from.  If\n"
         "no drive letter is specified, this defaults to booting from the A drive.\n"
@@ -4783,6 +4788,8 @@ void DOS_SetupPrograms(void) {
     MSG_Add("PROGRAM_BOOT_CART_LIST_CMDS","Available PCjr cartridge commandos:%s");
     MSG_Add("PROGRAM_BOOT_CART_NO_CMDS","No PCjr cartridge commandos found");
 
+    MSG_Add("PROGRAM_LOADROM_HELP","LOADROM ROM_file\n");
+    MSG_Add("PROGRAM_LOADROM_HELP","Must specify ROM file to load.\n");
     MSG_Add("PROGRAM_LOADROM_SPECIFY_FILE","Must specify ROM file to load.\n");
     MSG_Add("PROGRAM_LOADROM_CANT_OPEN","ROM file not accessible.\n");
     MSG_Add("PROGRAM_LOADROM_TOO_LARGE","ROM file too large.\n");
diff --git a/src/dosbox.cpp b/src/dosbox.cpp
index 14d011f7fe6..c804e8b8976 100644
--- a/src/dosbox.cpp
+++ b/src/dosbox.cpp
@@ -3075,11 +3075,6 @@ void DOSBOX_SetupConfigSections(void) {
             "If unset or invalid, the default name CLIP$ will be used (e.g. \"TYPE CLIP$\" shows the clipboard contents).\n"
 			"It has no effect if \"dos clipboard device enable\" is false, and it is deactivated if the secure mode is enabled.");
 
-    Pint = secprop->Add_int("dos clipboard paste speed", Property::Changeable::WhenIdle, 20);
-    Pint->Set_help("Set keyboard speed for pasting from the Windows clipboard.\n"
-        "If the default setting of 20 causes lost keystrokes, increase the number.\n"
-        "Or experiment with decreasing the number for applications that accept keystrokes quickly.");
-
     secprop=control->AddSection_prop("ipx",&Null_Init,true);
     Pbool = secprop->Add_bool("ipx",Property::Changeable::WhenIdle, false);
     Pbool->Set_help("Enable ipx over UDP/IP emulation.");
@@ -3286,8 +3281,8 @@ void DOSBOX_SetupConfigSections(void) {
         "You can put your MOUNT lines here.\n"
     );
     MSG_Add("CONFIGFILE_INTRO",
-            "# This is the configuration file for DOSBox %s. (Please use the latest version of DOSBox)\n"
-            "# Lines starting with a # are comment lines and are ignored by DOSBox.\n"
+            "# This is the configuration file for DOSBox-X %s. (Please use the latest version of DOSBox-X)\n"
+            "# Lines starting with a # are comment lines and are ignored by DOSBox-X.\n"
             "# They are used to (briefly) document the effect of each option.\n"
         "# To write out ALL options, use command 'config -all' with -wc or -writeconf options.\n");
     MSG_Add("CONFIG_SUGGESTED_VALUES", "Possible values");
diff --git a/src/gui/sdl_gui.cpp b/src/gui/sdl_gui.cpp
index 8e3650f3b8b..761f7bd397e 100644
--- a/src/gui/sdl_gui.cpp
+++ b/src/gui/sdl_gui.cpp
@@ -1299,7 +1299,7 @@ class ConfigurationWindow : public GUI::ToplevelWindow {
 static void UI_Execute(GUI::ScreenSDL *screen) {
     SDL_Surface *sdlscreen;
     SDL_Event event;
-    GUI::String configString = GUI::String("DOSBox Configuration");
+    GUI::String configString = GUI::String("DOSBox-X Configuration");
 
     sdlscreen = screen->getSurface();
     auto *cfg_wnd = new ConfigurationWindow(screen, 30, 30, configString);
@@ -1359,7 +1359,7 @@ static void UI_Select(GUI::ScreenSDL *screen, int select) {
     Section_prop *section = NULL;
     Section *sec = NULL;
     SDL_Event event;
-    GUI::String configString = GUI::String("DOSBox Configuration");
+    GUI::String configString = GUI::String("DOSBox-X Configuration");
 
     sdlscreen = screen->getSurface();
     switch (select) {
diff --git a/src/gui/sdlmain.cpp b/src/gui/sdlmain.cpp
index ec6ba7b0b7f..8d1476320fc 100644
--- a/src/gui/sdlmain.cpp
+++ b/src/gui/sdlmain.cpp
@@ -499,6 +499,9 @@ void FreeBIOSDiskList();
 void GFX_ShutDown(void);
 void MAPPER_Shutdown();
 void SHELL_Init(void);
+void PasteClipboard(bool bPressed);
+void CopyClipboard(void);
+
 #if C_DYNAMIC_X86
 void CPU_Core_Dyn_X86_Shutdown(void);
 #endif
@@ -659,6 +662,8 @@ bool                        dos_kernel_disabled = true;
 bool                        startup_state_numlock = false; // Global for keyboard initialisation
 bool                        startup_state_capslock = false; // Global for keyboard initialisation
 bool                        startup_state_scrlock = false; // Global for keyboard initialisation
+int mouse_start_x=-1, mouse_start_y=-1, mouse_end_x=-1, mouse_end_y=-1, fx=-1, fy=-1, paste_speed;
+const char *modifier;
 
 #if defined(WIN32) && !defined(C_SDL2)
 extern "C" void SDL1_hax_SetMenu(HMENU menu);
@@ -965,7 +970,7 @@ void PushDummySDL(void) {
 }
 
 static void HandleMouseMotion(SDL_MouseMotionEvent * motion);
-static void HandleMouseButton(SDL_MouseButtonEvent * button);
+static void HandleMouseButton(SDL_MouseButtonEvent * button, SDL_MouseMotionEvent * motion);
 
 #if defined(C_SDL2)
 # if !defined(IGNORE_TOUCHSCREEN)
@@ -1075,10 +1080,10 @@ void PauseDOSBoxLoop(Bitu /*unused*/) {
             if (touchscreen_finger_lock == no_finger_id &&
                 touchscreen_touch_lock == no_touch_id &&
                 event.button.which != SDL_TOUCH_MOUSEID) { /* don't handle mouse events faked by touchscreen */
-                HandleMouseButton(&event.button);
+                HandleMouseButton(&event.button,&event.motion);
             }
 #else
-            HandleMouseButton(&event.button);
+            HandleMouseButton(&event.button,&event.motion);
 #endif
             break;
 #if defined(C_SDL2)
@@ -3344,6 +3349,9 @@ static void GUI_StartUp() {
     else if (feedback == "flash")
         sdl.mouse.autolock_feedback = AUTOLOCK_FEEDBACK_FLASH;
 
+	modifier = section->Get_string("clip_key_modifier");
+    paste_speed = (unsigned int)section->Get_int("clip_paste_speed");
+
     Prop_multival* p3 = section->Get_multival("sensitivity");
     sdl.mouse.xsensitivity = p3->GetSection()->Get_int("xsens");
     sdl.mouse.ysensitivity = p3->GetSection()->Get_int("ysens");
@@ -3477,7 +3485,6 @@ static void GUI_StartUp() {
     MAPPER_AddHandler(SwitchFullScreen,MK_f,MMODHOST,"fullscr","Fullscreen", &item);
     item->set_text("Toggle fullscreen");
 
-    void PasteClipboard(bool bPressed); // emendelson from dbDOS adds MMOD2 to this for Ctrl-Alt-F5 for PasteClipboard
     MAPPER_AddHandler(PasteClipboard, MK_nothing, 0, "paste", "Paste Clipboard"); //end emendelson
 #if C_DEBUG
     /* Pause binds with activate-debugger */
@@ -3887,8 +3894,18 @@ static void HandleMouseMotion(SDL_MouseMotionEvent * motion) {
         inputToScreen = false;
     else if (sdl.mouse.locked || Mouse_GetButtonState() != 0)
         inputToScreen = true;
-    else
+    else {
         inputToScreen = GFX_CursorInOrNearScreen(motion->x,motion->y);
+#if defined (WIN32)
+		if (mouse_start_x >= 0 && &mouse_start_y >= 0) {
+			if (fx>=0 && fy>=0)
+				Restore_Text(mouse_start_x-sdl.clip.x,mouse_start_y-sdl.clip.y,fx-sdl.clip.x,fy-sdl.clip.y,currentWindowWidth-sdl.clip.x,currentWindowHeight-sdl.clip.y);
+			Mouse_Select(mouse_start_x-sdl.clip.x,mouse_start_y-sdl.clip.y,motion->x-sdl.clip.x,motion->y-sdl.clip.y,currentWindowWidth-sdl.clip.x,currentWindowHeight-sdl.clip.y);
+			fx=motion->x;
+			fy=motion->y;
+		}
+#endif
+	}
 
 #if DOSBOXMENU_TYPE == DOSBOXMENU_SDLDRAW /* SDL drawn menus */
     if (GFX_GetPreventFullscreen()) {
@@ -4051,7 +4068,7 @@ void MenuFreeScreen(void) {
 }
 #endif
 
-static void HandleMouseButton(SDL_MouseButtonEvent * button) {
+static void HandleMouseButton(SDL_MouseButtonEvent * button, SDL_MouseMotionEvent * motion) {
     bool inputToScreen = false;
     bool inMenu = false;
 
@@ -4554,6 +4571,17 @@ static void HandleMouseButton(SDL_MouseButtonEvent * button) {
     switch (button->state) {
     case SDL_PRESSED:
         if (inMenu || !inputToScreen) return;
+#if defined(WIN32)
+		if (!sdl.mouse.locked && button->button == SDL_BUTTON_RIGHT && (!strcmp(modifier,"none")
+			|| (!strcmp(modifier,"alt") || !strcmp(modifier,"lalt")) && sdl.laltstate==SDL_KEYDOWN || (!strcmp(modifier,"alt") || !strcmp(modifier,"ralt")) && sdl.raltstate==SDL_KEYDOWN
+			|| (!strcmp(modifier,"ctrl") || !strcmp(modifier,"lctrl")) && sdl.lctrlstate==SDL_KEYDOWN || (!strcmp(modifier,"ctrl") || !strcmp(modifier,"rctrl")) && sdl.rctrlstate==SDL_KEYDOWN
+			|| (!strcmp(modifier,"shift") || !strcmp(modifier,"lshift")) && sdl.lshiftstate==SDL_KEYDOWN || (!strcmp(modifier,"shift") || !strcmp(modifier,"rshift")) && sdl.rshiftstate==SDL_KEYDOWN
+			)) {
+			mouse_start_x=motion->x;
+			mouse_start_y=motion->y;
+			break;
+		} else
+#endif
         if (sdl.mouse.requestlock && !sdl.mouse.locked && mouse_notify_mode == 0) {
             CaptureMouseNotify();
             GFX_CaptureMouse();
@@ -4585,6 +4613,28 @@ static void HandleMouseButton(SDL_MouseButtonEvent * button) {
         }
         break;
     case SDL_RELEASED:
+#if defined(WIN32)
+		if (!sdl.mouse.locked && button->button == SDL_BUTTON_RIGHT && mouse_start_x >= 0 && &mouse_start_y >= 0) {
+			mouse_end_x=motion->x;
+			mouse_end_y=motion->y;
+			if (mouse_start_x == mouse_end_x && mouse_start_y == mouse_end_y)
+				PasteClipboard(true);
+			else {
+				Restore_Text(mouse_start_x-sdl.clip.x,mouse_start_y-sdl.clip.y,fx-sdl.clip.x,fy-sdl.clip.y,currentWindowWidth-sdl.clip.x,currentWindowHeight-sdl.clip.y);
+				if (abs(mouse_end_x - mouse_start_x) + abs(mouse_end_y - mouse_start_y)<5) {
+					PasteClipboard(true);
+				} else
+					CopyClipboard();
+			}
+			mouse_start_x = -1;
+			mouse_start_y = -1;
+			mouse_end_x = -1;
+			mouse_end_y = -1;
+			fx = -1;
+			fy = -1;
+			break;
+		}
+#endif
         switch (button->button) {
         case SDL_BUTTON_LEFT:
             Mouse_ButtonReleased(0);
@@ -4611,6 +4661,10 @@ static void HandleMouseButton(SDL_MouseButtonEvent * button) {
 void GFX_LosingFocus(void) {
     sdl.laltstate=SDL_KEYUP;
     sdl.raltstate=SDL_KEYUP;
+    sdl.lctrlstate=SDL_KEYUP;
+    sdl.rctrlstate=SDL_KEYUP;
+    sdl.lshiftstate=SDL_KEYUP;
+    sdl.rshiftstate=SDL_KEYUP;
     MAPPER_LosingFocus();
     DoExtendedKeyboardHook(false);
 }
@@ -4716,7 +4770,7 @@ static void FingerToFakeMouseMotion(SDL_TouchFingerEvent * finger) {
         fakeb.button = SDL_BUTTON_LEFT;
         fakeb.x = fake.x;
         fakeb.y = fake.y;
-        HandleMouseButton(&fakeb);
+        HandleMouseButton(&fakeb,&fake);
     }
 }
 
@@ -5020,10 +5074,10 @@ void GFX_Events() {
             if (touchscreen_finger_lock == no_finger_id &&
                 touchscreen_touch_lock == no_touch_id &&
                 event.button.which != SDL_TOUCH_MOUSEID) { /* don't handle mouse events faked by touchscreen */
-                HandleMouseButton(&event.button);
+                HandleMouseButton(&event.button,&event.motion);
             }
 #else
-            HandleMouseButton(&event.button);
+            HandleMouseButton(&event.button,&event.motion);
 #endif
             break;
 #if !defined(IGNORE_TOUCHSCREEN)
@@ -5271,7 +5325,7 @@ void GFX_Events() {
             break;
         case SDL_MOUSEBUTTONDOWN:
         case SDL_MOUSEBUTTONUP:
-            HandleMouseButton(&event.button);
+            HandleMouseButton(&event.button,&event.motion);
             break;
         case SDL_VIDEORESIZE:
             UpdateWindowDimensions(); // FIXME: Use SDL window dimensions, except that on Windows, SDL won't tell us our actual dimensions
@@ -5289,6 +5343,10 @@ void GFX_Events() {
             // ignore event alt+tab
             if (event.key.keysym.sym==SDLK_LALT) sdl.laltstate = event.key.type;
             if (event.key.keysym.sym==SDLK_RALT) sdl.raltstate = event.key.type;
+            if (event.key.keysym.sym==SDLK_LCTRL) sdl.lctrlstate = event.key.type;
+            if (event.key.keysym.sym==SDLK_RCTRL) sdl.rctrlstate = event.key.type;
+            if (event.key.keysym.sym==SDLK_LSHIFT) sdl.lshiftstate = event.key.type;
+            if (event.key.keysym.sym==SDLK_RSHIFT) sdl.rshiftstate = event.key.type;
             if (((event.key.keysym.sym==SDLK_TAB)) &&
                 ((sdl.laltstate==SDL_KEYDOWN) || (sdl.raltstate==SDL_KEYDOWN))) { MAPPER_LosingFocus(); break; }
             // This can happen as well.
@@ -5315,18 +5373,15 @@ void GFX_Events() {
     // keystrokes get lost in the spew. (Prob b/c of DI usage on Win32, sadly..)
     // while (PasteClipboardNext());
     // Doesn't really matter though, it's fast enough as it is...
-    int paste_speed = 20;
-    Section* sec = control->GetSection("dos");
-    Section_prop* section = static_cast<Section_prop*>(sec);
-    paste_speed = (unsigned int)section->Get_int("dos clipboard paste speed");
+	if (paste_speed < 0) paste_speed = 20;
 
     static Bitu iPasteTicker = 0;
-    if ((iPasteTicker++ % paste_speed) == 0) // emendelson: was %2, %20 is good for WP51
+    if (paste_speed && (iPasteTicker++ % paste_speed) == 0) // emendelson: was %2, %20 is good for WP51
         PasteClipboardNext();   // end added emendelson from dbDOS
 #endif
 }
 
-// added emendelson from dbDos
+// added emendelson from dbDos; improved by Wengier
 #if defined(WIN32) && !defined(C_SDL2) && !defined(__MINGW32__)
 #include <cassert>
 
@@ -5614,13 +5669,27 @@ void PasteClipboard(bool bPressed)
     ::CloseClipboard();
 }
 /// TODO: add menu items here 
-#else // end emendelson from dbDOS
+#else // end emendelson from dbDOS; improved by Wengier
+# if defined(WIN32) && defined(C_SDL2)
+void PasteClipboard(bool bPressed) {
+	if (!bPressed) return;
+	char *text = NULL;
+	long len = 0;
+	if (OpenClipboard(NULL)) {
+		text = (char*)GetClipboardData(CF_OEMTEXT);
+	if (text!=NULL)
+		for (unsigned int i=0;i<strlen(text);i++)
+			if (text[i] != 0x0A)
+				BIOS_AddKeyToBuffer(text[i]);
+	}
+	CloseClipboard();
+}
+# else
 void PasteClipboard(bool bPressed) {
     (void)bPressed;//UNUSED
     // stub
 }
 
-# if !defined(C_SDL2)
 bool PasteClipboardNext() {
     // stub
     return false;
@@ -5630,6 +5699,21 @@ bool PasteClipboardNext() {
 
 
 #if defined (WIN32)
+void CopyClipboard(void) {
+	const char* text = Mouse_GetSelected(mouse_start_x-sdl.clip.x,mouse_start_y-sdl.clip.y,mouse_end_x-sdl.clip.x,mouse_end_y-sdl.clip.y,currentWindowWidth-sdl.clip.x,currentWindowHeight-sdl.clip.y);
+	if (OpenClipboard(NULL)) {
+		HGLOBAL clipbuffer;
+		char * buffer;
+		EmptyClipboard();
+		clipbuffer = GlobalAlloc(GMEM_DDESHARE, strlen(text)+1);
+		buffer = (char*)GlobalLock(clipbuffer);
+		strcpy(buffer, text);
+		GlobalUnlock(clipbuffer);
+		SetClipboardData(CF_OEMTEXT,clipbuffer);
+		CloseClipboard();
+	}
+}
+
 static BOOL WINAPI ConsoleEventHandler(DWORD event) {
     switch (event) {
     case CTRL_SHUTDOWN_EVENT:
@@ -5734,6 +5818,17 @@ void SDL_SetupConfigSection() {
     Pstring->Set_help("Autolock status feedback type, i.e. visual, auditive, none.");
     Pstring->Set_values(feeds);
 
+	const char* clipboardmodifier[] = { "none", "alt", "lalt", "ralt", "ctrl", "lctrl", "rctrl", "shift", "lshift", "rshift", "disabled", 0};
+	Pstring = sdl_sec->Add_string("clip_key_modifier",Property::Changeable::Always, "disabled");
+	Pstring->Set_values(clipboardmodifier);
+	Pstring->Set_help("Change the keyboard modifier for the Windows clipboard copy/paste function using the right mouse button.\n"
+		"Set to \"none\" if no modifier is desired. Set to \"disabled\" will disable this feature (default).");
+
+    Pint = sdl_sec->Add_int("clip_paste_speed", Property::Changeable::WhenIdle, 20);
+    Pint->Set_help("Set keyboard speed for pasting from the Windows clipboard.\n"
+        "If the default setting of 20 causes lost keystrokes, increase the number.\n"
+        "Or experiment with decreasing the number for applications that accept keystrokes quickly.");
+
     Pmulti = sdl_sec->Add_multi("sensitivity",Property::Changeable::Always, ",");
     Pmulti->Set_help("Mouse sensitivity. The optional second parameter specifies vertical sensitivity (e.g. 100,-50).");
     Pmulti->SetValue("100");
@@ -5961,10 +6056,11 @@ static void printconfiglocation() {
 }
 
 static void eraseconfigfile() {
-    FILE* f = fopen("dosbox.conf","r");
+    FILE* f = fopen("dosbox-x.conf","r");
+	if (!f) f = fopen("dosbox.conf","r");
     if(f) {
         fclose(f);
-        show_warning("Warning: dosbox.conf exists in current working directory.\nThis will override the configuration file at runtime.\n");
+        show_warning("Warning: dosbox-x.conf (or dosbox.conf) exists in current working directory.\nThis will override the configuration file at runtime.\n");
     }
     std::string path,file;
     Cross::GetPlatformConfigDir(path);
@@ -5978,11 +6074,12 @@ static void eraseconfigfile() {
 }
 
 static void erasemapperfile() {
-    FILE* g = fopen("dosbox.conf","r");
+    FILE* g = fopen("dosbox-x.conf","r");
+	if (!g) g = fopen("dosbox.conf","r");
     if(g) {
         fclose(g);
-        show_warning("Warning: dosbox.conf exists in current working directory.\nKeymapping might not be properly reset.\n"
-                     "Please reset configuration as well and delete the dosbox.conf.\n");
+        show_warning("Warning: dosbox-x.conf (or dosbox.conf) exists in current working directory.\nKeymapping might not be properly reset.\n"
+                     "Please reset configuration as well and delete the dosbox-x.conf (or dosbox.conf).\n");
     }
 
     std::string path,file=MAPPERFILE;
@@ -6108,9 +6205,9 @@ bool DOSBOX_parse_argv() {
         if (optname == "version") {
             DOSBox_ShowConsole();
 
-            fprintf(stderr,"\nDOSBox version %s %s, copyright 2002-2019 DOSBox Team.\n\n",VERSION,SDL_STRING);
-            fprintf(stderr,"DOSBox is written by the DOSBox Team (See AUTHORS file))\n");
-            fprintf(stderr,"DOSBox comes with ABSOLUTELY NO WARRANTY.  This is free software,\n");
+            fprintf(stderr,"\nDOSBox-X version %s %s, copyright 2011-2020 joncampbell123.\n",VERSION,SDL_STRING);
+            fprintf(stderr,"Based on DOSBox by the DOSBox Team (See AUTHORS file)\n\n");
+            fprintf(stderr,"DOSBox-X comes with ABSOLUTELY NO WARRANTY.  This is free software,\n");
             fprintf(stderr,"and you are welcome to redistribute it under certain conditions;\n");
             fprintf(stderr,"please read the COPYING file thoroughly before doing so.\n\n");
 
@@ -6120,12 +6217,13 @@ bool DOSBOX_parse_argv() {
 
             return 0;
         }
-        else if (optname == "h" || optname == "help") {
+        else if (optname == "?" || optname == "h" || optname == "help") {
             DOSBox_ShowConsole();
 
-            fprintf(stderr,"\ndosbox [options]\n");
-            fprintf(stderr,"\nDOSBox version %s %s, copyright 2002-2019 DOSBox Team.\n\n",VERSION,SDL_STRING);
-            fprintf(stderr,"  -h     -help                            Show this help\n");
+            fprintf(stderr,"\ndosbox-x [options]\n");
+            fprintf(stderr,"\nDOSBox-X version %s %s, copyright 2011-2020 joncampbell123.\n",VERSION,SDL_STRING);
+            fprintf(stderr,"Based on DOSBox by the DOSBox Team (See AUTHORS file)\n\n");
+            fprintf(stderr,"  -?, -h, -help                           Show this help\n");
             fprintf(stderr,"  -editconf                               Launch editor\n");
             fprintf(stderr,"  -opencaptures <param>                   Launch captures\n");
             fprintf(stderr,"  -opensaves <param>                      Launch saves\n");
@@ -7625,7 +7723,8 @@ int main(int argc, char* argv[]) SDL_MAIN_NOEXCEPT {
             }
         }
 
-        /* -- -- if none found, use dosbox.conf */
+        /* -- -- if none found, use dosbox-x.conf or dosbox.conf */
+        if (!control->configfiles.size()) control->ParseConfigFile("dosbox-x.conf");
         if (!control->configfiles.size()) control->ParseConfigFile("dosbox.conf");
 
         /* -- -- if none found, use userlevel conf */
@@ -7815,6 +7914,10 @@ int main(int argc, char* argv[]) SDL_MAIN_NOEXCEPT {
         /* assume L+R ALT keys are up */
         sdl.laltstate = SDL_KEYUP;
         sdl.raltstate = SDL_KEYUP;
+        sdl.lctrlstate = SDL_KEYUP;
+        sdl.rctrlstate = SDL_KEYUP;
+        sdl.lshiftstate = SDL_KEYUP;
+        sdl.rshiftstate = SDL_KEYUP;
 
 #if defined(WIN32) && !defined(C_SDL2)
 # if SDL_VERSION_ATLEAST(1, 2, 10)
diff --git a/src/hardware/ide.cpp b/src/hardware/ide.cpp
index 139a36ba93d..a230e21de8c 100644
--- a/src/hardware/ide.cpp
+++ b/src/hardware/ide.cpp
@@ -3379,12 +3379,12 @@ void IDEATADevice::writecommand(uint8_t cmd) {
             uint64_t n;
 
             n = ((unsigned int)(drivehead&0xF)<<24)+((unsigned int)lba[2]<<16)+((unsigned int)lba[1]<<8)+(unsigned int)lba[0];
-            LOG_MSG("IDE ATA command %02x dh=0x%02x count=0x%02x lba=%07llx/%07llx\n",cmd,
+            LOG(LOG_SB,LOG_DEBUG)("IDE ATA command %02x dh=0x%02x count=0x%02x lba=%07llx/%07llx\n",cmd,
                 drivehead,count,(unsigned long long)n,
                 (unsigned long long)(phys_sects * phys_cyls * phys_heads));
         }
         else {
-            LOG_MSG("IDE ATA command %02x dh=0x%02x count=0x%02x chs=%02x/%02x/%02x\n",cmd,
+            LOG(LOG_SB,LOG_DEBUG)("IDE ATA command %02x dh=0x%02x count=0x%02x chs=%02x/%02x/%02x\n",cmd,
                 drivehead,count,((unsigned int)lba[2]<<8)+(unsigned int)lba[1],(unsigned int)(drivehead&0xF),(unsigned int)lba[0]);
         }
 
diff --git a/src/ints/mouse.cpp b/src/ints/mouse.cpp
index 28d99e0d084..1e6b7b4b5dc 100644
--- a/src/ints/mouse.cpp
+++ b/src/ints/mouse.cpp
@@ -707,6 +707,77 @@ uint8_t Mouse_GetButtonState(void) {
     return mouse.buttons;
 }
 
+#if defined(WIN32)
+char text[50*81];
+const char* Mouse_GetSelected(int x1, int y1, int x2, int y2, int w, int h) {
+	Bit8u page = real_readb(BIOSMEM_SEG,BIOSMEM_CURRENT_PAGE);
+	Bit16u c=real_readw(BIOSMEM_SEG,BIOSMEM_NB_COLS), r=(Bit16u)real_readb(BIOSMEM_SEG,BIOSMEM_NB_ROWS)+1;
+	int c1=c*x1/w, r1=r*y1/h, c2=c*x2/w, r2=r*y2/h, t;
+	char str[2];
+	if (c1>c2) {
+		t=c1;
+		c1=c2;
+		c2=t;
+	}
+	if (r1>r2) {
+		t=r1;
+		r1=r2;
+		r2=t;
+	}
+	Bit16u result;
+	text[0]=0;
+	for (int i=r1; i<=r2; i++) {
+		for (int j=c1; j<=c2; j++) {
+			ReadCharAttr(j,i,page,&result);
+			sprintf(str,"%c",result);
+			if (str[0]==0) continue;
+			strcat(text,str);
+		}
+		while (strlen(text)>0&&text[strlen(text)-1]==32) text[strlen(text)-1]=0;
+		if (i<r2) strcat(text,"\r\n");
+	}
+	return text;
+}
+
+void Mouse_Select(int x1, int y1, int x2, int y2, int w, int h) {
+	Bit8u page = real_readb(BIOSMEM_SEG,BIOSMEM_CURRENT_PAGE);
+	Bit16u c=real_readw(BIOSMEM_SEG,BIOSMEM_NB_COLS), r=(Bit16u)real_readb(BIOSMEM_SEG,BIOSMEM_NB_ROWS)+1;
+	int c1=c*x1/w, r1=r*y1/h, c2=c*x2/w, r2=r*y2/h, t;
+	if (c1>c2) {
+		t=c1;
+		c1=c2;
+		c2=t;
+	}
+	if (r1>r2) {
+		t=r1;
+		r1=r2;
+		r2=t;
+	}
+	for (int i=r1; i<=r2; i++)
+		for (int j=c1; j<=c2; j++)
+			real_writeb(0xb800,(i*c+j)*2+1,real_readb(0xb800,(i*c+j)*2+1)^119);
+}
+
+void Restore_Text(int x1, int y1, int x2, int y2, int w, int h) {
+	Bit8u page = real_readb(BIOSMEM_SEG,BIOSMEM_CURRENT_PAGE);
+	Bit16u c=real_readw(BIOSMEM_SEG,BIOSMEM_NB_COLS), r=(Bit16u)real_readb(BIOSMEM_SEG,BIOSMEM_NB_ROWS)+1;
+	int c1=c*x1/w, r1=r*y1/h, c2=c*x2/w, r2=r*y2/h, t;
+	if (c1>c2) {
+		t=c1;
+		c1=c2;
+		c2=t;
+	}
+	if (r1>r2) {
+		t=r1;
+		r1=r2;
+		r2=t;
+	}
+	for (int i=r1; i<=r2; i++)
+		for (int j=c1; j<=c2; j++)
+			real_writeb(0xb800,(i*c+j)*2+1,real_readb(0xb800,(i*c+j)*2+1)^119);
+}
+#endif
+
 void Mouse_ButtonPressed(Bit8u button) {
     if (!IS_PC98_ARCH && KEYBOARD_AUX_Active()) {
         switch (button) {
diff --git a/src/misc/programs.cpp b/src/misc/programs.cpp
index 87f5a505c8d..94ffebd4f95 100644
--- a/src/misc/programs.cpp
+++ b/src/misc/programs.cpp
@@ -629,8 +629,8 @@ void CONFIG::Run(void) {
 				// write config to startup directory
 				writeconf(pvars[0], false, all);
 			} else {
-				// -wcp without parameter: write dosbox.conf to startup directory
-				if (control->configfiles.size()) writeconf(std::string("dosbox.conf"), false, all);
+				// -wcp without parameter: write dosbox-x.conf to startup directory
+				if (control->configfiles.size()) writeconf(std::string("dosbox-x.conf"), false, all);
 				else WriteOut(MSG_Get("PROGRAM_CONFIG_NOCONFIGFILE"));
 			}
 			break;
@@ -1058,7 +1058,7 @@ void PROGRAMS_Init() {
 	MSG_Add("PROGRAM_CONFIG_NOCONFIGFILE","No config file loaded!\n");
 	MSG_Add("PROGRAM_CONFIG_PRIMARY_CONF","Primary config file: \n%s\n");
 	MSG_Add("PROGRAM_CONFIG_ADDITIONAL_CONF","Additional config files:\n");
-	MSG_Add("PROGRAM_CONFIG_CONFDIR","DOSBox %s configuration directory: \n%s\n\n");
+	MSG_Add("PROGRAM_CONFIG_CONFDIR","DOSBox-X %s configuration directory: \n%s\n\n");
 	
 	// writeconf
 	MSG_Add("PROGRAM_CONFIG_FILE_ERROR","\nCan't open file %s\n");
@@ -1070,7 +1070,7 @@ void PROGRAMS_Init() {
 		"-writeconf or -wc with filename: write file to config directory.\n"\
 		"Use -writelang or -wl filename to write the current language strings.\n"\
 		"-all  Use -all with -wc and -writeconf to write ALL options to the file.\n"\
-		"-wcp [filename]\n Write config file to the program directory, dosbox.conf or the specified \n filename.\n"\
+		"-wcp [filename]\n Write config file to the program directory, dosbox-x.conf or the specified \n filename.\n"\
 		"-wcd\n Write to the default config file in the config directory.\n"\
 		"-l lists configuration parameters.\n"\
 		"-h, -help, -? sections / sectionname / propertyname\n"\
@@ -1083,13 +1083,13 @@ void PROGRAMS_Init() {
         " Switches to secure mode where MOUNT, IMGMOUNT and BOOT will be disabled\n"\
         " as well as the ability to create config and language files.\n"\
 		"-get \"section property\" returns the value of the property.\n"\
-		"-set \"section property=value\" sets the value." );
+		"-set \"section property=value\" sets the value.\n" );
 	MSG_Add("PROGRAM_CONFIG_HLP_PROPHLP","Purpose of property \"%s\" (contained in section \"%s\"):\n%s\n\nPossible Values: %s\nDefault value: %s\nCurrent value: %s\n");
 	MSG_Add("PROGRAM_CONFIG_HLP_LINEHLP","Purpose of section \"%s\":\n%s\nCurrent value:\n%s\n");
 	MSG_Add("PROGRAM_CONFIG_HLP_NOCHANGE","This property cannot be changed at runtime.\n");
 	MSG_Add("PROGRAM_CONFIG_HLP_POSINT","positive integer"); 
 	MSG_Add("PROGRAM_CONFIG_HLP_SECTHLP","Section %s contains the following properties:\n");				
-	MSG_Add("PROGRAM_CONFIG_HLP_SECTLIST","DOSBox configuration contains the following sections:\n\n");
+	MSG_Add("PROGRAM_CONFIG_HLP_SECTLIST","DOSBox-X configuration contains the following sections:\n\n");
 
 	MSG_Add("PROGRAM_CONFIG_SECURE_ON","Switched to secure mode.\n");
 	MSG_Add("PROGRAM_CONFIG_SECURE_DISALLOW","This operation is not permitted in secure mode.\n");
@@ -1099,6 +1099,6 @@ void PROGRAMS_Init() {
 	MSG_Add("PROGRAM_CONFIG_NO_PROPERTY","There is no property %s in section %s.\n");
 	MSG_Add("PROGRAM_CONFIG_SET_SYNTAX","Correct syntax: config -set \"section property=value\".\n");
 	MSG_Add("PROGRAM_CONFIG_GET_SYNTAX","Correct syntax: config -get \"section property\".\n");
-	MSG_Add("PROGRAM_CONFIG_PRINT_STARTUP","\nDOSBox was started with the following command line parameters:\n%s");
+	MSG_Add("PROGRAM_CONFIG_PRINT_STARTUP","\nDOSBox-X was started with the following command line parameters:\n%s");
 	MSG_Add("PROGRAM_CONFIG_MISSINGPARAM","Missing parameter.");
 }
diff --git a/src/shell/shell.cpp b/src/shell/shell.cpp
index 7425d5bb80e..66142a2d257 100644
--- a/src/shell/shell.cpp
+++ b/src/shell/shell.cpp
@@ -1117,6 +1117,9 @@ void SHELL_Init() {
 	MSG_Add("SHELL_CMD_CTTY_HELP_LONG","CTTY device\n  device\tThe terminal device to use, such as CON.\n");
 	MSG_Add("SHELL_CMD_MORE_HELP","Displays output one screen at a time.\n");
 	MSG_Add("SHELL_CMD_MORE_HELP_LONG","MORE [drive:][path][filename]\nMORE < [drive:][path]filename\ncommand-name | MORE [drive:][path][filename]\n");
+	MSG_Add("SHELL_CMD_TRUENAME_HELP","Finds the fully-expanded name for a file.\n");
+	MSG_Add("SHELL_CMD_TRUENAME_HELP_LONG","TRUENAME file\n");
+
 
 	/* Regular startup */
 	call_shellstop=CALLBACK_Allocate();
diff --git a/src/shell/shell_cmds.cpp b/src/shell/shell_cmds.cpp
index c48f8bafa67..83f350b476f 100644
--- a/src/shell/shell_cmds.cpp
+++ b/src/shell/shell_cmds.cpp
@@ -87,6 +87,7 @@ static SHELL_Cmd cmd_list[]={
 {	"MORE",	1,			&DOS_Shell::CMD_MORE,		"SHELL_CMD_MORE_HELP"},
 {	"FOR",	1,			&DOS_Shell::CMD_FOR,		"SHELL_CMD_FOR_HELP"},
 {	"LFNFOR",	1,			&DOS_Shell::CMD_LFNFOR,		"SHELL_CMD_LFNFOR_HELP"},
+{	"TRUENAME",	1,			&DOS_Shell::CMD_TRUENAME,		"SHELL_CMD_TRUENAME_HELP"},
 {	"INT2FDBG",	1,			&DOS_Shell::CMD_INT2FDBG,	"Hook INT 2Fh for debugging purposes.\n"},
 {   "DX-CAPTURE",1,         &DOS_Shell::CMD_DXCAPTURE,  "Run program with video/audio capture.\n"},
 #if C_DEBUG
@@ -874,7 +875,7 @@ static bool doDir(DOS_Shell * shell, char * args, DOS_DTA dta, char * numformat,
     if (*(sargs+strlen(sargs)-1) != '\\') strcat(sargs,"\\");
 
 	Bit32u cbyte_count=0,cfile_count=0,w_count=0;
-	bool ret=DOS_FindFirst(args,0xffff & ~DOS_ATTR_VOLUME);
+	bool ret=DOS_FindFirst(args,0xffff & ~DOS_ATTR_VOLUME), found=true;
 	if (ret) {
 		std::vector<DtaResult> results;
 
@@ -981,19 +982,23 @@ static bool doDir(DOS_Shell * shell, char * args, DOS_DTA dta, char * numformat,
 			}
 		}
 
-		if (optW&&w_count%5) shell->WriteOut("\n");
+		if (!results.size())
+			found=false;
+		else if (optW&&w_count%5)
+			shell->WriteOut("\n");
 	} else
-		if (!optB) {
-			shell->WriteOut(MSG_Get("SHELL_CMD_FILE_NOT_FOUND"),args);
-			p_count+=optW?5:1;
-			if (optP && p_count%(22*w_size)<1) {
-				shell->WriteOut(MSG_Get("SHELL_CMD_PAUSE"));
-				Bit8u c;Bit16u n=1;
-				DOS_ReadFile(STDIN,&c,&n);
-				if (c==3) {shell->WriteOut("^C\r\n");return false;}
-				if (c==0) DOS_ReadFile(STDIN,&c,&n); // read extended key
-			}
+		found=false;
+	if (!found&&!optB) {
+		shell->WriteOut(MSG_Get("SHELL_CMD_FILE_NOT_FOUND"),args);
+		p_count+=optW?5:1;
+		if (optP && p_count%(22*w_size)<1) {
+			shell->WriteOut(MSG_Get("SHELL_CMD_PAUSE"));
+			Bit8u c;Bit16u n=1;
+			DOS_ReadFile(STDIN,&c,&n);
+			if (c==3) {shell->WriteOut("^C\r\n");return false;}
+			if (c==0) DOS_ReadFile(STDIN,&c,&n); // read extended key
 		}
+	}
 	if (optS) {
 		size_t len=strlen(sargs);
 		strcat(sargs, "*.*");
@@ -2022,7 +2027,7 @@ void DOS_Shell::CMD_TIME(char * args) {
 	}
 }
 
-void DOS_Shell::CMD_SUBST (char * args) {
+void DOS_Shell::CMD_SUBST(char * args) {
 /* If more that one type can be substed think of something else 
  * E.g. make basedir member dos_drive instead of localdrive
  */
@@ -2383,6 +2388,25 @@ void DOS_Shell::CMD_VOL(char *args){
 	return;
 }
 
+void DOS_Shell::CMD_TRUENAME(char * args) {
+	HELP("TRUENAME");
+	args = trim(args);
+	if (!*args) {
+		WriteOut("No file name given.\n");
+		return;
+	}
+	if (char* rem = ScanCMDRemain(args)) {
+		WriteOut("Invalid switch - %s\n", rem);
+		return;
+	}
+	char *name = StripArg(args), fullname[DOS_PATHLENGTH];
+	Bit8u drive;
+	if (DOS_MakeName(name, fullname, &drive))
+		WriteOut("%c:\\%s\r\n", drive+'A', fullname);
+	else
+		WriteOut(dos.errorcode==DOSERR_PATH_NOT_FOUND?"Path not found\n":"File not found\n");
+}
+
 void SetVal(const std::string& secname, const std::string& preval, const std::string& val);
 static void delayed_press(Bitu key) { KEYBOARD_AddKey((KBD_KEYS)key,true); }
 static void delayed_release(Bitu key) { KEYBOARD_AddKey((KBD_KEYS)key,false); }
diff --git a/src/shell/shell_misc.cpp b/src/shell/shell_misc.cpp
index 89ea92cea20..6310755a4f4 100644
--- a/src/shell/shell_misc.cpp
+++ b/src/shell/shell_misc.cpp
@@ -903,7 +903,8 @@ bool DOS_Shell::Execute(char * name,char * args) {
 				DOS_ReadFile (STDIN,&c,&n);
 				do switch (c) {
 					case 0xD: WriteOut("\n\n"); WriteOut(MSG_Get("SHELL_EXECUTE_DRIVE_NOT_FOUND"),toupper(name[0])); return true;
-					case 0x08: WriteOut("\b \b"); goto first_2;
+					case 0x3: WriteOut("^C\n");return true;
+					case 0x8: WriteOut("\b \b"); goto first_2;
 				} while (DOS_ReadFile (STDIN,&c,&n));
 			}
 			case 'y':			case 'Y':
@@ -912,9 +913,11 @@ bool DOS_Shell::Execute(char * name,char * args) {
 				DOS_ReadFile (STDIN,&c,&n);
 				do switch (c) {
 					case 0xD: WriteOut("\n"); goto continue_1;
-					case 0x08: WriteOut("\b \b"); goto first_2;
+					case 0x3: WriteOut("^C\n");return true;
+					case 0x8: WriteOut("\b \b"); goto first_2;
 				} while (DOS_ReadFile (STDIN,&c,&n));
 			}
+			case 0x3: WriteOut("^C\n");return true;
 			case 0xD: WriteOut("\n"); goto first_1;
 			case '\t': case 0x08: goto first_2;
 			default:
@@ -923,7 +926,8 @@ bool DOS_Shell::Execute(char * name,char * args) {
 				DOS_ReadFile (STDIN,&c,&n);
 				do switch (c) {
 					case 0xD: WriteOut("\n");goto first_1;
-					case 0x08: WriteOut("\b \b"); goto first_2;
+					case 0x3: WriteOut("^C\n");return true;
+					case 0x8: WriteOut("\b \b"); goto first_2;
 				} while (DOS_ReadFile (STDIN,&c,&n));
 				goto first_2;
 			}
